'-------------------------------------------------------------------------------
'                         MMCSD_Analysis.BAS
'                         Test MMC / SD Card
'        (c) 2003-2012 , MCS Electronics / Vgel Franz Josef
'-------------------------------------------------------------------------------
' Test MMC / SD Card
' Show the Card Capacity and the Card-Register CSD, CID, OCR and SD_Status
' First you have to init the Card in the File Config_MMCSD_HC.bas with
' $Include "Config_MMCSD_HC.bas"
' All Card registers are written with the MSB first to the Byte-array
' f.E. CSD(1) contains then MSB (Bit 120-127) of the CSD-Register

$regfile = "m644pdef.dat"
$crystal = 16000000

'konfiguracja przestrzenie pracy dla funkcji
$hwstack = 100
$swstack = 100
$framesize = 100

'konfiguracja prdkoci transmisji danych do komputera przez RS232
$baud = 9600

'do prawidowej pracy biblioteki konfigurujemy zegar sprztowy korzystajcy z kwarcu 32768Hz podpitego midzy piny PC6 i PC7
Config Clock = Soft
Config Date = Dmy , Separator = .
Time$ = "12:00:00"
Date$ = "29.12.10"
'jeli nie chcemy korzysta z zegara, a chcemy normalnie uywa pinw PC6 i 7 to wykonujemy
'odblokowanie pinw PC6 i 7 dla procesorw atmega16/32:
'(
Tccr2 = 0
Assr = 0
Timsk = 0
Tifr = 0
')

'UWAGA! Kody te naley umieci zaraz po konfiguracji zegara, i przed  konfiguracj
'do innych zada jakichkolwiek timerw i/lub przerwa. W przeciwnym razie  mog one zosta le skonfigurowane

'wczamy przerwania
Enable Interrupts
Poczatek:
'doczamy plik z programem inicjalizujcym kart SD i system plikw
$include "Card_init.bas"
'jeli inicjalizacja przebiega pomylnie to wykonujemy program
Print
Print
If Card_init_error = 0 Then
   'Sprawdzamy i wywietlamy typ podpitej karty pamici
   Select Case Mmcsd_cardtype
     Case 1
       Print "MMC-Card detected"
     Case 2
       Print "SD-Card Spec. 1.x detected"
     Case 4
       Print "SD-Card Spec. 2.0 detected"
     Case 12
       Print "SD-Card Spec. 2.0 High Capacity detected"
     Case Else
       Print "No Card detected"
   End Select
'------------------------ZAPIS--------------------------------------------------

   Print "Zapisuje dane do pliku plik.txt"
   'znajdujemy wolny uchwty (identyfikator) do otwarcia pliku
   Ff = Freefile()
   'otwieramy plik (uwaga, pliki, ktre obsuguje biblioteka maj nazw maksymalnie postaci 8.3, czyli 8 znakw, kropka i 3 znaki)
   'Moemy otwiera tez pliki o krtszych rozszerzeniach, lub wogle bez rozszerzenia, ale pamitajmy, e nazwa moe mie maksymalnie dugo 8 znakw.
   'wpisanie np. 123456789AB spowoduje utworzenie pliku 12345678.9AB, pomimo, e nie podalimy kropki
   'otwieramy plik plik.txt w trybie do zapisu na uchwycie #ff
   'jeli plik nie istnia to zostanie utworzony
   'a jeli istnia to jego dotychczasowa zawarto zostanie teraz skasowana
   Open "plik.txt" For Output As #ff
   'zapisujemy jaki tekst do pliku
   Print #ff , "Ten tekst zapiszemy do pliku"
   Print #ff , "To bdzie (podobnie jak w wysyaniu danych przez RS232) druga linijka pliku"
   Dim A As Byte
   A = 123
   Print #ff , "Podobnie jak na LCD moemy zapisa dowolne zmienne: " ; A ;
   'dziki rednikowi na kocu powyszej linijki dlasze dane bda w tej samej linijce
   Print #ff , " i ku mojemu zaskoczeniu take polskie znaki: 󹜳ӥ"
   'i zamykamy plik
   Close #ff
'------------------------Dopisywanie--------------------------------------------

   Print "Dopisuje dane do pliku jakispli"
   Ff = Freefile()
   'otwieramy plik w trybie do dopisywania
   'jeli plik nie istnia to zostanie otwarty, jeli istnia to nowe dane bd dopisywane na jego kocu
   Open "jakispli" For Append As #ff
   Print #ff , "To ju ente uruchomienie programu!"
   Print #ff , "Gratulacje!"
   Close #ff
'------------------------Odczyt-------------------------------------------------

   Dim S As String * 80
   'zmienna, ktra bdzie przechowywa tekst z pliku

   Print "Odczytuje dane z pliku odczyt.txt"
   Ff = Freefile()
   'otwieramy plik do odczytu
   Open "odczyt.txt" For Input As #ff
   Print "Rozmiar pliku: " ; Lof(#ff) ; " B"
   'funkcja Lof(#uchwyt) zwraca dugo pliku (rozmiar w bajtach)
   Do
      Line Input #ff , S
      'pobieramy jedn linijk z pliku
      Print S
      'i wywietlamy j w terminalu
   Loop Until Eof(#ff) <> 0
   'funkcja Eof(#uchwyt) zwraca liczb rn od zera (najczciej 255), jeli dojdziemy do koca pliku
   Close #ff
'------------------------Zapis zmiennych jako csv-------------------------------
   Print "Zapisuje do pliku csv"
   Ff = Freefile()
   Open "plik.csv" For Output As #ff
   'zapisujemy zmienne
   Dim B As Integer , C As Word
   A = 10
   B = 25
   C = 1234
   S = "Jakis tekst do zapisu"
   Write #ff , A , B , C                                    'te dane zostan zapisane w pierwszym wierszu
   Write #ff , S                                            'ta dana pjdzie do 2 wiersza
   Close #ff
'------------------------Odczyt zmiennych z csv---------------------------------
   Print "Czytam z pliku csv"
   Ff = Freefile()
   Open "read.csv" For Input As #ff
   Input #ff , A                                            'odczytujemy kolejne pola pliku csv
   Input #ff , B
   Input #ff , C
   Input #ff , S
   Close #ff
   Print "A= " ; A                                          'i je wywietlamy na ekranie komputera
   Print "B= " ; B
   Print "C= " ; C
   Print "S= " ; S
'------------------------Tryb binarny-------------------------------------------
   Print "Zapisuje do pliku BIN"
   Ff = Freefile()
   'otwieramy plik w trybie binarnym
   Open "plik.bin" For Binary As #ff
   A = 34
   Put #ff , A                                              'przygotowujemy liczb do zapisu
   Flush #ff                                                'i j zapisujemy
   B = 300
   Put #ff , B
   Flush #ff
   Dim Pointer As Long
   Pointer = Loc(#ff)                                       'pobieramy pozycj, pod ktr zpisalimy zmienn B (jej ostatni bajt)
   Incr Pointer                                             'ale teraz chcemy wskazywa na kolejny adres
   Print "Tekst zapiszemy pod adresem: " ; Pointer
   S = "Tekst"
   Put #ff , S                                              'pod ktrym zapiszemy tekst
   A = 0
   Put #ff , A                                              'dodajemy jeden bajt na koniec pliku, aby podczas odczytu plik sie nie zamyka z powodu osignicia jego koca.
   Flush #ff
   Close #ff

   Ff = Freefile()
   Open "plik.bin" For Binary As #ff
   A = 0                                                    'kasujemy zmiene, eby miec pewno , e zostan oczytane z karty
   B = 0
   C = 0
   S = ""
   Print "A teraz odczyt"
   Get #ff , A , 1                                          'pobieramy zmienn z pierwszej pozycji
   'Skadnia Get #uchwyt, zmienna do zapisu odczytanych danych
   'Opcjonalnie kolejne parametry: Get #uchwyt, zmienna, pozycja rozpoczcia odczytu danych, liczba bajtw do pobrania
   Print "A= " ; A
   Get #ff , S , Pointer                                    'pobieramy stringa spod adresu zapamitanego w zmiennej pointer
   Get #ff , A , 1                                          'pobieramy zmienn spod adresu 0
   Get #ff , B                                              'kolejna zmienna zostanie pobrana z kolejnego adresu (automatyczna inkrementacja)
   Print "A= " ; A
   Print "B= " ; B
   Print "S= " ; S
   Close #ff
'------------------------Wyszukiwanie plikw------------------------------------

   Ff = Freefile()
   Open "dane.txt" For Binary As #ff
   Print #ff , "abcdefghijklmnopqrstuvwxyz"
   Close #ff

   Ff = Freefile()
   Open "dane.abc" For Binary As #ff
   Print #ff , "abcABCabcABC"
   Close #ff

   Ff = Freefile()
   Open "test2.txt" For Binary As #ff
   Print #ff , "to jest plik tekstowy"
   Close #ff

   Ff = Freefile()
   Open "testowy.pl" For Binary As #ff
   Print #ff , "jakis inny tekst"
   Close #ff
   'tworzymy par plikw do testowania

   Print
   Print "Wszystkie pliki w katalogu: "

   S = Dir( "*.*")
   'bdziemy wuszyukiwa dowolne pliki o dowlonym rozszerzeniu
   While Len(s) > 0
      'powtarzamy dopki instrukcja nie zwrci pustego cigu, czyli dopki wszystkie pliki nie zostan wyszukane
      Print S ; " " ; Filedate() ; " " ; Filetime() ; " " ; Filelen() ; "B"
      'wywietlamy nazwe pliku, dat i czas jego ostatniej modyfikacji oraz rozmiar w bajtach
      'instrukcji moemy uywa take dla dowolnego pliku podajc w nawiasach jego nazw, np.:
      'Filelen("test2.txt")
      S = Dir()
      'indeksujemy kolejny plik (nie musimy ju podawa maski, wtedy poprzednie wyszukiwanie bdzie kontynuowane)
   Wend

   Print
   Print "Pliki tekstowe: "

   S = Dir( "*.txt")
   While Len(s) > 0
       Print S ; " " ; Filedate() ; " " ; Filetime() ; " " ; Filelen() ; "B"
       S = Dir()
   Wend

   Print
   Print "Pliki pasujace do wzoru dane.*: "

   S = Dir( "dane.*")
   While Len(s) > 0
      Print S ; " " ; Filedate() ; " " ; Filetime() ; " " ; Filelen() ; "B"
      S = Dir()
   Wend
'------------------------Kasowanie plikw---------------------------------------
   Print "Kasujemy conieco"
   Kill "testowy.pl"


'------------------------Katalogi na karcie-------------------------------------
   Print "Jeszcze troche zabawy z katalogami na karcie"
   Mkdir "katalog1"
   Mkdir "katalog2"
   'tworzymy katalogi
   Rmdir "katalog1"
   'usuwamy jeden z nich
   Chdir "katalog2"
   'przechodzimy do okrelonego katalogu


   Ff = Freefile()
   Open "plik.txt" For Output As #ff
   Print #ff , "ten plik jest zapisany w katalogu katalog2"
   Close #ff
   'tworzymy plik w katalogu

   Chdir ".."
   'przechodzimy o jeden poziom wyej (do katalogu gwnego)

   Ff = Freefile()
   Open "plikg.txt" For Output As #ff
   Print #ff , "ten plik jest zapisany w katalogu glownym"
   Close #ff
   'tworzymy plik w katalogu gwnym

   Mkdir "test1"
   Chdir "test1"
   Mkdir "test11"
   Chdir "test11"
   'tworzymy katalogi zagniedone

   Ff = Freefile()
   Open "plik.txt" For Output As #ff
   Print #ff , "ten plik jest zapisany w katalogu zagniezdzonym"
   Close #ff
   'ten plik znajdzie si w zagniedonych katalogach

   Print "Gotowe - sprwdz zawartosc karty na komputerze!!"

Else                                                        'jeli karta nie zostala prawidowo zainicjalizowana to wywietlamy komunikat o bdzie
   Print "Podczas inicjalizacji wystapily bledy: " ; Card_init_error
   'w normalnym programie moemy sprbowa przeprowadzi w jakiej ptli (np. co 1s) ponown prb inicjalizacji karty wywouc nastpuje instrukcje:
   '(
   Gbdriveerror = Driveinit()
   If Gbdriveerror = 0 Then
      Btemp1 = Initfilesystem(1)
      'jeli dotrzemy do tego miejsca i Btemp1 == 0 to wtedy karta zostaa pomylnie zainicjalizowana
      'w kadym innym wypadku dalej mamy bd
   End If
')
   'tu dla czytelnoci przykadu wykonamy bardzo nieeleganck rzecz, jak jest skok do etykiety na pocztku programu
   ' (pamitajmy jednak, ze jest to ostateczno - takie instrukcje nie powinny si pojawia w dobrze napisanym programie)
   Wait 1
   Goto Poczatek
End If

End